#!/bin/sh

# Usage: config.os config.mak config.h system_name

config_mak=$1
config_h=$2
system_name=$3

if test -z "$system_name" ; then
  # OS name
  system_name=`( uname -s ) 2>&1`
  case "$system_name" in
  Linux|FreeBSD|NetBSD|BSD/OS|OpenBSD|SunOS|QNX)
    ;;
  IRIX*)
    system_name=IRIX
    ;;
  [cC][yY][gG][wW][iI][nN]*)
    system_name=CYGWIN
    ;;
  *)
    system_name="$system_name-UNKNOWN"
    ;;
  esac
fi

cat > $config_mak << EOF
TARGET_OS = $system_name
EOF

cat > $config_h << EOF
/* system name: not used */
EOF

echo "$system_name"
