/*
   codecs_ld - light interface to codec loader
*/

#include <stdio.h>
#include <dlfcn.h>
#include <string.h>
#include "codecs_ld.h"
#include "config.h"
#include "mp_msg.h"

#define MSG_FATAL(args...) mp_msg(MSGT_GLOBAL,MSGL_FATAL, ##args )
#define MSG_HINT(args...) mp_msg(MSGT_GLOBAL,MSGL_HINT, ##args )
#define MSG_INFO(args...) mp_msg(MSGT_GLOBAL,MSGL_INFO, ##args )

void * ld_codec(const char *name,const char *url_hint)
{
  void *dll_handle;
  if(!(dll_handle=dlopen(name,RTLD_LAZY|RTLD_GLOBAL)))
  {
    MSG_FATAL("codec_ld: Can't load library: '%s' due: %s\n",name,dlerror());
    if(url_hint) MSG_HINT("codec_ld: Try obtain this codec at: %s\n",url_hint);
    return NULL;
  }
  MSG_INFO("codec_ld: The library: '%s' was loaded OK\n",name);
  return dll_handle;
}

/* this code should be called before thread creating */
static char cname[FILENAME_MAX];
char * codec_name( const char *name )
{
  strcpy(cname,LIBDIR"/codecs/");
  strcat(cname,name);
  return cname;
}

char * wineld_name( const char *name )
{
  strcpy(cname,LIBDIR"/wine/");
  strcat(cname,name);
  return cname;
}

