/* This file contains reenterable interface to demuxer */
#include <stdlib.h>

#include "stream.h"
#include "demuxer.h"
#include "stheader.h"
#include "demuxer_r.h"

pthread_mutex_t demuxer_mutex=PTHREAD_MUTEX_INITIALIZER;

int demux_getc_r(demux_stream_t *ds)
{
    int retval;
    LOCK_DEMUXER();
    retval = demux_getc(ds);
    UNLOCK_DEMUXER();
    return retval;
}

int video_read_frame_r(sh_video_t* sh_video,float* frame_time_ptr,unsigned char** start,int force_fps)
{
    int retval;
    LOCK_DEMUXER();
    retval = video_read_frame(sh_video,frame_time_ptr,start,force_fps);
    UNLOCK_DEMUXER();
    return retval;
}

int demux_read_data_r(demux_stream_t *ds,unsigned char* mem,int len)
{
    int retval;
    LOCK_DEMUXER();
    retval = demux_read_data(ds,mem,len);
    UNLOCK_DEMUXER();
    return retval;
}

int ds_get_packet_r(demux_stream_t *ds,unsigned char **start)
{
    int retval;
    LOCK_DEMUXER();
    retval = ds_get_packet(ds,start);
    UNLOCK_DEMUXER();
    return retval;
}


/* TODO : FIXME we need to redesign blocking of mutexes before enabling this function*/
int demux_seek_r(demuxer_t *demuxer,float rel_seek_secs,int flags)
{
    int retval;
//    LOCK_DEMUXER();
    retval = demux_seek(demuxer,rel_seek_secs,flags);
//    UNLOCK_DEMUXER();
    return retval;
}
